#ifdef ATL_UCLEANM
#define ATL_sJIK0x24x24TN24x24x0_a1_bX ATL_sgpMBmm_bX
#else
#define ATL_sJIK0x24x24TN24x24x0_a1_bX ATL_spMBmm_bX
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x24x24TN1x3x4_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=24, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=1, nu=3, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + 576;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*3)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 4
   const int incAm = 0, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 4
   const int incBm = -24, incBn = 72;
   #define incCm 1
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2;
   register float rC0_0, rC0_1, rC0_2;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         for (k=24; k; k -= 4) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[24];
            rB2 = pB0[48];
            rC0_0 += rA0 * rB0;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[25];
            rB2 = pB0[49];
            rC0_0 += rA0 * rB0;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[26];
            rB2 = pB0[50];
            rC0_0 += rA0 * rB0;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rB1 = pB0[27];
            rB2 = pB0[51];
            rC0_0 += rA0 * rB0;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x24x24TN24x24x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=24, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=5, nu=3, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/5)*5;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + 576;
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*5*3)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 4
   const int incAm = 96, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 4
   const int incBm = -24, incBn = 72;
   #define incCm 5
   const int incCn = (((ldc) << 1)+ldc) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4;
   register float rB0, rB1, rB2;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC1_1 = pC1[1];
            rC1_1 *= rA0;
            rC2_1 = pC1[2];
            rC2_1 *= rA0;
            rC3_1 = pC1[3];
            rC3_1 *= rA0;
            rC4_1 = pC1[4];
            rC4_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC1_2 = pC2[1];
            rC1_2 *= rA0;
            rC2_2 = pC2[2];
            rC2_2 *= rA0;
            rC3_2 = pC2[3];
            rC3_2 *= rA0;
            rC4_2 = pC2[4];
            rC4_2 *= rA0;
            for (k=24; k; k -= 4) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[24];
               rA2 = pA0[48];
               rA3 = pA0[72];
               rA4 = pA0[96];
               rC0_0 += rA0 * rB0;
               rB1 = pB0[24];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[48];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[25];
               rA2 = pA0[49];
               rA3 = pA0[73];
               rA4 = pA0[97];
               rC0_0 += rA0 * rB0;
               rB1 = pB0[25];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[49];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[26];
               rA2 = pA0[50];
               rA3 = pA0[74];
               rA4 = pA0[98];
               rC0_0 += rA0 * rB0;
               rB1 = pB0[26];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[50];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[27];
               rA2 = pA0[51];
               rA3 = pA0[75];
               rA4 = pA0[99];
               rC0_0 += rA0 * rB0;
               rB1 = pB0[27];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[51];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            *pC1 = rC0_1;
            pC1[1] = rC1_1;
            pC1[2] = rC2_1;
            pC1[3] = rC3_1;
            pC1[4] = rC4_1;
            *pC2 = rC0_2;
            pC2[1] = rC1_2;
            pC2[2] = rC2_2;
            pC2[3] = rC3_2;
            pC2[4] = rC4_2;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x24x24TN1x3x4_a1_bX(k, 24, 24, alpha, ca + (((Mb) << 4)+((Mb) << 3)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
